import { jsx as d, jsxs as x, Fragment as A } from "react/jsx-runtime";
import i from "clsx";
import * as h from "react";
import S, { useId as O, useRef as F, useEffect as D } from "react";
import { useFloating as j, useClick as W, useDismiss as G, useRole as X, useInteractions as Y, useMergeRefs as q, FloatingPortal as H, FloatingOverlay as J, FloatingFocusManager as K } from "@floating-ui/react";
/*!
  @versini/ui-panel v1.2.6
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PANEL__ || (window.__VERSINI_UI_PANEL__ = {
    version: "1.2.6",
    buildTime: "12/30/2024 11:40 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const R = "av-messagebox", C = "av-panel", L = "av-button", T = "icon", Q = "button", Z = "link", ee = ({
  type: e,
  size: t,
  labelRight: r,
  labelLeft: o,
  align: a
}) => {
  const n = "text-sm font-medium max-h-8 py-0", c = "text-base font-medium max-h-9 py-1", l = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case Q:
      return i("px-4", {
        [n]: t === "small",
        [c]: t === "medium",
        [l]: t === "large"
      });
    case Z:
      return i("px-4 text-center", {
        [n]: t === "small",
        [c]: t === "medium",
        [l]: t === "large"
      });
    case T:
      return i("inline-flex items-center", {
        "justify-center": a === "center",
        "justify-start": a === "left",
        "justify-end": a === "right",
        "h-6 w-6 p-0": t === "small" && !(r || o),
        "h-6 px-4 text-sm font-medium": t === "small" && (r || o),
        "h-8 w-8 p-1": t === "medium" && !(r || o),
        "h-8 px-4 text-base font-medium": t === "medium" && (r || o),
        "h-12 w-12 p-2": t === "large" && !(r || o),
        "h-12 px-4 text-lg font-medium": t === "large" && (r || o)
      });
  }
}, re = ({
  mode: e,
  noBackground: t,
  noTruncate: r,
  variant: o,
  radius: a
}) => {
  if (t)
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small"
    });
  if (o === "primary")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !r,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (o === "secondary")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !r,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (o === "danger")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !r,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
  if (o === "selected")
    return i("not-prose", {
      "rounded-full": a === "large",
      "rounded-md": a === "medium",
      "rounded-sm": a === "small",
      truncate: !r,
      "bg-action-selected-dark text-copy-light": e === "dark",
      "bg-action-selected-light text-copy-lighter": e === "light",
      "bg-action-selected-dark text-copy-light dark:bg-action-selected-light dark:text-copy-lighter": e === "system",
      "bg-action-selected-light text-copy-lighter dark:bg-action-selected-dark dark:text-copy-light": e === "alt-system"
    });
}, te = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (r === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (r === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (r === "selected")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-selected-dark-hover": e === "dark",
      "hover:bg-action-selected-light-hover": e === "light",
      "hover:bg-action-selected-dark-hover dark:hover:bg-action-selected-light-hover": e === "system",
      "hover:bg-action-selected-light-hover dark:hover:bg-action-selected-dark-hover": e === "alt-system"
    });
}, ae = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (r === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (r === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (r === "selected")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-selected-dark-active": e === "dark",
      "active:bg-action-selected-light-active": e === "light",
      "active:bg-action-selected-dark-active dark:active:bg-action-selected-light-active": e === "system",
      "active:bg-action-selected-light-active dark:active:bg-action-selected-dark-active": e === "alt-system"
    });
}, oe = ({
  mode: e,
  noBorder: t,
  variant: r
}) => {
  if (t)
    return "border border-transparent";
  if (r === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (r === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (r === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (r === "selected")
    return i("border", {
      "border-border-selected-dark": e === "dark",
      "border-border-selected-medium": e === "light",
      "border-border-selected-dark dark:border-border-selected-medium": e === "system",
      "border-border-selected-medium dark:border-border-selected-dark": e === "alt-system"
    });
}, ie = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), $ = ({
  type: e,
  className: t,
  raw: r,
  mode: o,
  focusMode: a,
  disabled: n,
  fullWidth: c,
  size: l,
  noBorder: m,
  labelRight: g,
  labelLeft: b,
  noBackground: f,
  variant: s,
  noTruncate: u,
  align: v,
  radius: p
}) => (s || (s = "primary"), r ? i(L, t) : i(
  L,
  re({
    mode: o,
    variant: s,
    noBackground: f,
    noTruncate: u,
    radius: p
  }),
  ee({ type: e, size: l, labelRight: g, labelLeft: b, align: v }),
  oe({ mode: o, variant: s, noBorder: m }),
  ie({ focusMode: a }),
  te({ mode: o, variant: s, disabled: n }),
  ae({ mode: o, variant: s, disabled: n }),
  {
    "w-full": c,
    "disabled:cursor-not-allowed disabled:opacity-50": n
  },
  t
)), de = (e, t, r) => {
  var o;
  !t && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((o = e == null ? void 0 : e.currentTarget) == null ? void 0 : o.focus) == "function" && e.currentTarget.focus(), typeof r == "function" && r(e);
}, M = S.forwardRef((e, t) => {
  const { onClick: r, noInternalClick: o = !1, ...a } = e;
  return /* @__PURE__ */ d(
    "button",
    {
      ref: t,
      onClick: (n) => {
        de(n, o, r);
      },
      ...a
    }
  );
});
M.displayName = "BaseButton";
const V = S.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: o = "system",
    fullWidth: a = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: m = !1,
    "aria-label": g,
    label: b,
    size: f = "medium",
    labelRight: s,
    labelLeft: u,
    noBackground: v = !1,
    align: p = "center",
    radius: k = "large",
    ...N
  }, I) => {
    const E = $({
      type: T,
      mode: r,
      focusMode: o,
      fullWidth: a,
      disabled: t,
      raw: l,
      className: n,
      noBorder: m,
      size: f,
      labelRight: s,
      labelLeft: u,
      noBackground: v,
      align: p,
      radius: k
    }), B = i({
      "text-copy-accent-dark": r === "light" && !l,
      "text-copy-light": r === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !l
    });
    return /* @__PURE__ */ x(
      M,
      {
        ref: I,
        className: E,
        disabled: t,
        type: c,
        "aria-label": g || b,
        ...N,
        children: [
          u && /* @__PURE__ */ d("span", { className: "pr-2", children: u }),
          /* @__PURE__ */ d("div", { className: B, children: e }),
          s && /* @__PURE__ */ d("span", { className: "pl-2", children: s })
        ]
      }
    );
  }
);
V.displayName = "ButtonIcon";
/*!
  @versini/ui-button v2.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "2.1.0",
    buildTime: "12/30/2024 11:40 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const le = S.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: o = "system",
    fullWidth: a = !1,
    className: n,
    type: c = "button",
    raw: l = !1,
    noBorder: m = !1,
    "aria-label": g,
    label: b,
    size: f = "medium",
    labelRight: s,
    labelLeft: u,
    noBackground: v = !1,
    align: p = "center",
    active: k = !1,
    radius: N = "large",
    ...I
  }, E) => {
    const B = $({
      type: T,
      mode: r,
      focusMode: o,
      fullWidth: a,
      disabled: t,
      raw: l,
      className: n,
      noBorder: m,
      size: f,
      labelRight: s,
      labelLeft: u,
      noBackground: v,
      align: p,
      radius: N
    }), U = i({
      "text-copy-accent-dark": r === "light" && !l,
      "text-copy-light": r === "dark" && !l,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !l,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !l
    }), z = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": r === "dark",
        "after:border-table-light": r === "light",
        "after:border-table-dark dark:after:border-table-light": r === "system",
        "after:border-table-light dark:after:border-table-dark": r === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ d("div", { className: z, children: /* @__PURE__ */ x(
      M,
      {
        ref: E,
        className: B,
        disabled: t,
        type: c,
        "aria-label": g || b,
        ...I,
        children: [
          u && /* @__PURE__ */ d("span", { className: "pr-2", children: u }),
          /* @__PURE__ */ d("div", { className: U, children: e }),
          s && /* @__PURE__ */ d("span", { className: "pl-2", children: s })
        ]
      }
    ) });
  }
);
le.displayName = "ButtonSort";
const ne = ({
  children: e,
  fill: t,
  viewBox: r,
  className: o,
  defaultViewBox: a,
  defaultClassName: n,
  title: c,
  semantic: l = !1,
  ...m
}) => {
  const g = i(o || n);
  return /* @__PURE__ */ x(A, { children: [
    /* @__PURE__ */ d(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: g,
        viewBox: r || a,
        fill: t || "currentColor",
        role: "img",
        "aria-hidden": !l,
        focusable: !1,
        ...m,
        children: e
      }
    ),
    c && l && /* @__PURE__ */ d("span", { className: "sr-only", children: c })
  ] });
};
/*!
  @versini/ui-svgicon v2.0.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "2.0.1",
    buildTime: "12/30/2024 11:40 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ce = ({
  className: e,
  viewBox: t,
  title: r,
  monotone: o,
  ...a
}) => /* @__PURE__ */ d(
  ne,
  {
    defaultViewBox: "0 0 384 512",
    defaultClassName: "size-5",
    viewBox: t,
    className: e,
    title: r || "Close",
    ...a,
    children: /* @__PURE__ */ d("path", { d: "M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3l105.4 105.3c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256l105.3-105.4z" })
  }
);
/*!
  @versini/ui-icons v2.0.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "2.0.1",
    buildTime: "12/30/2024 11:40 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const P = h.createContext(null);
function se({
  initialOpen: e = !1,
  open: t,
  onOpenChange: r
} = {}) {
  const [o, a] = h.useState(e), [n, c] = h.useState(), [l, m] = h.useState(), g = t ?? o, b = r ?? a, f = j({
    open: g,
    onOpenChange: b
  }), s = f.context, u = W(s, {
    enabled: t == null
  }), v = G(s, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), p = X(s), k = Y([u, v, p]);
  return h.useMemo(
    () => ({
      open: g,
      setOpen: b,
      ...k,
      ...f,
      labelId: n,
      descriptionId: l,
      setLabelId: c,
      setDescriptionId: m
    }),
    [g, b, k, f, n, l]
  );
}
const w = () => {
  const e = h.useContext(P);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function ge({
  children: e,
  ...t
}) {
  const r = se(t);
  return /* @__PURE__ */ d(P.Provider, { value: r, children: e });
}
const he = h.forwardRef(function(e, t) {
  const { context: r, ...o } = w(), a = q([o.refs.setFloating, t]);
  if (!r.open)
    return null;
  const { overlayBackground: n, ...c } = e, l = i("grid place-items-center", {
    [`${n}`]: n,
    "bg-black sm:bg-black/[.8]": !n
  });
  return /* @__PURE__ */ d(H, { children: /* @__PURE__ */ d(J, { className: l, lockScroll: !0, children: /* @__PURE__ */ d(K, { context: r, children: /* @__PURE__ */ d(
    "div",
    {
      ref: a,
      "aria-labelledby": o.labelId,
      "aria-describedby": o.descriptionId,
      ...o.getFloatingProps(c),
      children: c.children
    }
  ) }) }) });
}), me = h.forwardRef(function({ children: e, ...t }, r) {
  const { setLabelId: o } = w(), a = O();
  return h.useLayoutEffect(() => (o(a), () => o(void 0)), [a, o]), /* @__PURE__ */ d("h1", { ...t, ref: r, id: a, children: e });
}), ue = h.forwardRef(function({ children: e, ...t }, r) {
  const { setDescriptionId: o } = w(), a = O();
  return h.useLayoutEffect(() => (o(a), () => o(void 0)), [a, o]), /* @__PURE__ */ d("div", { ...t, ref: r, id: a, children: e });
}), be = h.forwardRef(function(e, t) {
  const { setOpen: r } = w(), { trigger: o, className: a, ...n } = e, c = h.useCallback(() => r(!1), [r]);
  return /* @__PURE__ */ d("div", { className: a, children: h.cloneElement(o, {
    ref: t,
    onClick: c,
    ...n
  }) });
});
/*!
  @versini/ui-modal v1.1.3
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_MODAL__ || (window.__VERSINI_UI_MODAL__ = {
    version: "1.1.3",
    buildTime: "12/30/2024 11:40 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const y = "panel", _ = "messagebox", fe = ({
  className: e,
  kind: t,
  borderMode: r
}) => ({
  main: i("prose prose-lighter flex flex-col bg-surface-medium", {
    [`${C} max-h-full sm:max-h-[95%] min-h-full sm:min-h-[10rem] sm:rounded-lg sm:border-2`]: t === y,
    [`${C} w-full sm:w-[95%] md:max-w-2xl`]: t === y && !e,
    [`${R} rounded-lg border-2`]: t === _,
    [`${R} w-[95%] sm:w-[50%] md:max-w-2xl`]: t === _ && !e,
    [`${e}`]: !!e,
    "sm:border-border-dark": r === "dark" && t === y,
    "sm:border-border-accent": r === "light" && t === y,
    "border-border-dark": r === "dark" && t === _,
    "border-border-accent": r === "light" && t === _
  }),
  content: "flex flex-col py-2 sm:py-4 sm:px-4 px-2 overflow-y-auto",
  footer: "flex flex-grow flex-col sm:p-4 p-2",
  header: "sm:p-4 mb-0 p-2",
  close: "sm:p-4 p-2"
}), xe = ({
  open: e,
  onOpenChange: t,
  title: r,
  children: o,
  footer: a,
  borderMode: n = "light",
  kind: c = y,
  className: l
}) => {
  const m = F(""), g = fe({ className: l, kind: c, borderMode: n });
  return D(() => (e && (m.current = document.title, document.title = `${r} | ${m.current}`), () => {
    e && (document.title = m.current);
  }), [r, e]), /* @__PURE__ */ d(A, { children: e && /* @__PURE__ */ d(ge, { open: e, onOpenChange: t, children: /* @__PURE__ */ x(he, { className: g.main, children: [
    /* @__PURE__ */ x("div", { className: "flex flex-row-reverse items-center justify-between", children: [
      /* @__PURE__ */ d(
        be,
        {
          className: g.close,
          trigger: /* @__PURE__ */ d(
            V,
            {
              mode: "dark",
              focusMode: "light",
              noBorder: !0,
              label: "Close",
              children: /* @__PURE__ */ d(ce, {})
            }
          )
        }
      ),
      /* @__PURE__ */ d(me, { className: g.header, children: r })
    ] }),
    /* @__PURE__ */ d(ue, { className: g.content, children: o }),
    a && /* @__PURE__ */ d("div", { className: g.footer, children: a })
  ] }) }) });
};
export {
  R as MESSAGEBOX_CLASSNAME,
  C as PANEL_CLASSNAME,
  xe as Panel
};
